/*
 * TismTool © Tis Veugen, 2010-2012
 * Simulation, Verification
 *
 * TsmAComponent.h
 * version 3
 */
#ifndef TSM_ACOMPONENT_H
#define TSM_ACOMPONENT_H

#include "TsmComponent.h"
#include "TsmThread.h"
using namespace std;

namespace TsmRTE
{
  /**
   * Active Component
   */
  class TsmAComponent : public TsmComponent
  {
  private:
    TsmThread* mThread;

  public:
    TsmThread* getThread()
    {
      return mThread;
    }

    void setThread( TsmThread* oThread )
    {
      this->mThread = oThread;
    }

    TsmAComponent()
    {
      mThread = new TsmThread();
    }

    virtual ~TsmAComponent()
    {
      delete mThread;
    }

    bool IsActive()
    {
      return true;
    }

    string ThreadId()
    {
      stringstream sb;
      sb << "," << mThread->mSequence;
      return sb.str();
    }

    virtual void TsmInitialise( void* oObject )
    {
      mThread->Prepare( this->TsmName );
    }

    virtual void TsmConnectAll( void* oObject )
    {
      TsmComponent::TsmConnectAll( mThread->getIntQueue() );
    }

    virtual void TsmPrepare( void* oObject )
    {
      mThread->Run();
    }

    virtual void TsmHalt( void* oObject )
    {
      mThread->Halt();
    }

    virtual void TsmCease( void* oObject )
    {
      mThread->Cease();
    }
  };
}
#endif
