/*
 * TismTool © Tis Veugen, 2010-2012
 * Simulation, Verification
 *
 * TsmClass.cpp
 * version 3
 */
#include <sstream>
#include <vector>
#include "TsmClass.h"
#include "TsmHandler.h"
#include "Util.h"
using namespace std;

namespace TsmRTE
{
  void TsmClass::TsmMention( void* oObject )
  {
    vector<TsmClass*> * ClassList = static_cast< vector<TsmClass*> * >( oObject );

    ClassList->push_back( this );
    this->SeqId = Tsm::SeqClass( this->FullName() );
  }

  void TsmClass::TsmReset1()
  {
    for ( int i=0; i<mNrFsms; i++ )
    {
      TsmHandler h( this );
      oFsms[i]->TsmReset1( h );
    }
    SnapState.clear(); // Invalidate SnapState
  }

  void TsmClass::TsmReset2()
  {
    for ( int i=0; i<mNrFsms; i++ )
    {
      TsmHandler h( this );
      oFsms[i]->TsmReset2( h );
    }
  }

  string TsmClass::TsmSnap()
  {
    if ( Util::IsNullOrEmpty( SnapState ) )
    {
      stringstream sb;
      sb << "{" << this->TsmName;
      for ( int i=0; i<mNrFsms; i++ )
      {
        sb << "/" << oFsms[i]->TsmSnap();
      }
      sb << "}";
      SnapState = sb.str();
    }
    return SnapState + SnapCall;
  }

  void TsmClass::TsmCheckVisit()
  {
    for ( int i=0; i<mNrFsms; i++ )
    {
      oFsms[i]->TsmCheckVisit();
    }
  }
}
