/*
 * TismTool © Tis Veugen, 2010-2012
 * Application, Simulation, Verification
 *
 * TsmHandler.h
 * version 1
 */
#ifndef TSM_HANDLER_H
#define TSM_HANDLER_H

#include "TsmClass.h"
#include "TsmTrigger.h"
#include "TsmSubFsm.h"
#include "TsmHandlerAction.h"
#include "TsmProspect.h"
using namespace std;

namespace TsmRTE
{
  class TsmHandler
  {
  public:
    int              Action;
    int              Index;
    int              Prospect;
    bool             bTaken;
    TsmClass*        Owner;
    TsmTrigger*      Trigger;
    TsmSubFsm*       TacSubFsm;

    TsmHandler()
      : Action( TsmHandlerAction::NONE )
      , Index( -1 )
      , Prospect( TsmProspect::NOK )
      , bTaken( false )
    {
    }

    TsmHandler( TsmClass* oOwner )
      : Action( TsmHandlerAction::NONE )
      , Index( -1 )
      , Prospect( TsmProspect::NOK )
      , bTaken( false )
      , Owner( oOwner )
    {
    }

    TsmHandler( TsmClass* oOwner, TsmTrigger* oTrigger )
      : Action( TsmHandlerAction::NONE )
      , Index( -1 )
      , Prospect( TsmProspect::NOK )
      , bTaken( false )
      , Owner( oOwner )
      , Trigger( oTrigger )
    {
    }
  };
}
#endif
