/*
 * TismTool © Tis Veugen, 2010-2012
 * Application, Simulation, Verification
 *
 * TsmState.h
 * version 2
 */
#ifndef TSM_STATE_H
#define TSM_STATE_H

#include "TsmBase.h"
#include "TsmTransition.h"
#include "TsmProspect.h"
using namespace std;

namespace TsmRTE
{
  class TsmHandler;

  class TsmState : public TsmBase
  {
  public:
    bool            bVisit;
    int             mNrTransitions;
    TsmTransition** mTransitions;

    TsmState()
      : bVisit( false )
      , mNrTransitions( 0 )
    {
    }

    virtual ~TsmState()
    {
      if ( mNrTransitions > 0 )
      {
        for ( int i=0; i<mNrTransitions; i++ )
        {
          delete mTransitions[i];
        }
        delete [] mTransitions;
      }
    }

    virtual void AtEntry( TsmHandler& oHandler )
    {
    }

    virtual void AtExit( TsmHandler& oHandler )
    {
    }

    virtual void Initial( TsmHandler& oHandler )
    {
    }

    virtual void Entrypoint( TsmHandler& oHandler )
    {
    }

    virtual void ExecuteTrigger( TsmHandler& oHandler );
    virtual void ExecuteTriggerless( TsmHandler& oHandler );

    virtual bool ExecuteTransition( TsmHandler& oHandler )
    {
      return true;
    }

    void ExecuteHandler( TsmHandler& oHandler );

    virtual int GetProspect( int PortId, int Command )
    {
      return TsmProspect::NOK;
    }

    virtual string TsmSnap()
    {
      return this->TsmName;
    }

    virtual void TsmCheckVisit();
  };
}
#endif
