/*
 * TismTool © Tis Veugen, 2010-2012
 * Application, Simulation, Verification
 *
 * TsmTriggerSem.h
 * version 2
 */
#ifndef TSM_TRIGGERSEM_H
#define TSM_TRIGGERSEM_H

#include <boost/thread/mutex.hpp>
#include <boost/thread/condition_variable.hpp>

namespace TsmRTE
{
  class TsmTriggerSem
  {
  private:
    boost::mutex              mMutex;
    boost::condition_variable mCondVar;
    bool                      mHasTrigger;

  public:
    TsmTriggerSem()
    {
      mHasTrigger = false;
    }

    void WaitOne()
    {
      boost::unique_lock<boost::mutex> lock( mMutex );
      if ( ! mHasTrigger )
      {
        mCondVar.wait( lock );
      }
      mHasTrigger = false;
    }

    void Release()
    {
      {
        boost::lock_guard<boost::mutex> lock( mMutex );
        mHasTrigger = true;
      }
      mCondVar.notify_one();
    }
  };
}
#endif
