/*
 * File: TsmSystem.h
 * Date: 12 aug 2012
 * Time: 21:04:52
 * Generated by TismTool version 0.9
 */

/*
 * Overview of identifications
 * ---------------------------
 * Ports:
 *     14 ( Xmi > Data > Protocols > TwinProtocol > TwinClient > Port )
 *     33 ( Xmi > Data > Protocols > OracleProtocol > OracleServer > Port )
 *     43 ( Xmi > Data > Protocols > OracleProtocol > OracleClient > Port )
 *     57 ( Xmi > Data > Repository > Twin > OracleComponent > OracleClass > Pythia )
 *     69 ( Xmi > Data > Repository > Twin > ActorComponent > ActorClass > rp_In )
 *     71 ( Xmi > Data > Repository > Twin > ActorComponent > ActorClass > rp_Oracle )
 *    101 ( Xmi > Data > Repository > Twin > TwinMock > TwinMockClass > rp_In2 )
 * Triggers:
 *      1 void ICbTwin___CbQuestion( String sQuestion )
 *      2 void ICbTwin___CbAnswer( String sAnswer )
 *      3 void IOracle___Ask( String sAsk )
 *      4 void ICbOracle___CbReply( String sReply )
 * Natives:
 *     29 ( TwinServerPsm >> Idle ) ->
 *        ( TwinServerPsm >> Idle )
 *        CbQuestion(sQuestion);
 *     30 ( TwinServerPsm >> Idle ) ->
 *        ( TwinServerPsm >> Idle )
 *        CbAnswer(sAnswer);
 *     41 ( OracleServerPsm >> Asked ) ->
 *        ( OracleServerPsm >> Idle )
 *        CbReply( \"This is answer of '\" + MyAsk + \"' !\" );
 *    -50 ( OracleClientPsm >> Idle ) ->
 *        ( OracleClientPsm >> Asking )
 *        Ask( sAsk );
 *    112 ( TwinMockFsm >> CompoundState >> Idle ) ->
 *        ( TwinMockFsm >> CompoundState >> Asking )
 *        pp_Out2->CbQuestion(\"My question?\");
 *    120 ( TwinMockFsm >> CompoundState >> Thinking ) ->
 *        ( TwinMockFsm >> CompoundState >> Answered )
 *        pp_Out2->CbAnswer(\"My answer!\");
 */

#ifndef TSM_SYSTEM_H
#define TSM_SYSTEM_H

#include "TsmIncludes.h"
#include "TsmInterfaces.h"
using namespace std;
using namespace TsmRTE;

namespace Twins
{
   // ( Xmi > Data > Repository > Twin > ActorComponent > ActorClass > ActorFsm >> InitialState )
  class Ini_0073_0074 : public TsmPseudo
  {
  public:
    Ini_0073_0074( TsmBase* oParent )
    {
      TsmName = "InitialState";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 94, "( ActorFsm >> InitialState ) => ( ActorFsm >> CompoundState )" );
    }

    void Initial( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 94: // UP: ( ActorFsm >> InitialState ) => ( ActorFsm >> CompoundState )
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Twin > ActorComponent > ActorClass > ActorFsm >> CompoundState >> InitialState )
  class Ini_0076_0077 : public TsmPseudo
  {
  public:
    Ini_0076_0077( TsmBase* oParent )
    {
      TsmName = "InitialState";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 82, "( ActorFsm >> CompoundState >> InitialState ) => ( ActorFsm >> CompoundState >> Idle )" );
    }

    void Initial( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 82: // UP: ( ActorFsm >> CompoundState >> InitialState ) => ( ActorFsm >> CompoundState >> Idle )
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Twin > ActorComponent > ActorClass > ActorFsm >> CompoundState >> FinalState )
  class Fin_0076_0078 : public TsmFinal
  {
  public:
    Fin_0076_0078( TsmBase* oParent )
    {
      TsmName = "FinalState";
      TsmParent = oParent;
      mNrTransitions = 0;
    }

    void Tra_0076_0086( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 86:
        Tra_0076_0086( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Twin > ActorComponent > ActorClass > ActorFsm >> CompoundState >> ChoiceState )
  class Cho_0076_0079 : public TsmPseudo
  {
  public:
    Cho_0076_0079( TsmBase* oParent )
    {
      TsmName = "ChoiceState";
      TsmParent = oParent;
      mNrTransitions = 2;
      mTransitions = new TsmTransition*[ 2 ];
      mTransitions[ 0 ] = new TsmTransition( 84, "( ActorFsm >> CompoundState >> ChoiceState ) => ( ActorFsm >> CompoundState >> Asking )" );
      mTransitions[ 1 ] = new TsmTransition( 86, "( ActorFsm >> CompoundState >> ChoiceState ) => ( ActorFsm >> CompoundState >> FinalState )" );
    }

    void Initial( TsmHandler& oHandler );
    void Tra_0076_0085( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 84: // UP: ( ActorFsm >> CompoundState >> ChoiceState ) => ( ActorFsm >> CompoundState >> Asking )
        bHigher = true;
        break;
      case 86: // UP: ( ActorFsm >> CompoundState >> ChoiceState ) => ( ActorFsm >> CompoundState >> FinalState )
        bHigher = true;
        break;
      case 85:
        Tra_0076_0085( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Twin > ActorComponent > ActorClass > ActorFsm >> CompoundState >> Idle )
  class Lea_0076_0080 : public TsmLeaf
  {
  public:
    Lea_0076_0080( TsmBase* oParent )
    {
      TsmName = "Idle";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 85, "( ActorFsm >> CompoundState >> Idle ) => ( ActorFsm >> CompoundState >> ChoiceState )" );
    }

    void Tra_0076_0082( TsmHandler& oHandler );
    void Initial( TsmHandler& oHandler );
    void Tra_0076_0083( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 82:
        Tra_0076_0082( oHandler );
        break;
      case 85: // UP: ( ActorFsm >> CompoundState >> Idle ) => ( ActorFsm >> CompoundState >> ChoiceState )
        bHigher = true;
        break;
      case 83:
        Tra_0076_0083( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Twin > ActorComponent > ActorClass > ActorFsm >> CompoundState >> Asking )
  class Lea_0076_0081 : public TsmLeaf
  {
  public:
    Lea_0076_0081( TsmBase* oParent )
    {
      TsmName = "Asking";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 83, "( ActorFsm >> CompoundState >> Asking ) => ( ActorFsm >> CompoundState >> Idle ) : rp_In->CbAnswer" );
    }

    void Tra_0076_0084( TsmHandler& oHandler );

    void Initial( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::OK;
    }
    void rp_In___CbAnswer( string sAnswer, TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void ExecuteTrigger( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 69:
        switch ( Command )
        {
        case 2:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 84:
        Tra_0076_0084( oHandler );
        break;
      case 83: // UP: ( ActorFsm >> CompoundState >> Asking ) => ( ActorFsm >> CompoundState >> Idle )
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Twin > ActorComponent > ActorClass > ActorFsm >> CompoundState >)
  class Reg_0075_0076 : public TsmRegion
  {
  private:
    Ini_0076_0077* oIni_0076_0077; // ( Xmi > Data > Repository > Twin > ActorComponent > ActorClass > ActorFsm >> CompoundState >> InitialState )
    Fin_0076_0078* oFin_0076_0078; // ( Xmi > Data > Repository > Twin > ActorComponent > ActorClass > ActorFsm >> CompoundState >> FinalState )
    Cho_0076_0079* oCho_0076_0079; // ( Xmi > Data > Repository > Twin > ActorComponent > ActorClass > ActorFsm >> CompoundState >> ChoiceState )
    Lea_0076_0080* oLea_0076_0080; // ( Xmi > Data > Repository > Twin > ActorComponent > ActorClass > ActorFsm >> CompoundState >> Idle )
    Lea_0076_0081* oLea_0076_0081; // ( Xmi > Data > Repository > Twin > ActorComponent > ActorClass > ActorFsm >> CompoundState >> Asking )

  public:
    Reg_0075_0076( TsmBase* oParent )
    {
      TsmName = "";
      TsmParent = oParent;
      oIni_0076_0077 = new Ini_0076_0077( this );
      oFin_0076_0078 = new Fin_0076_0078( this );
      oCho_0076_0079 = new Cho_0076_0079( this );
      oLea_0076_0080 = new Lea_0076_0080( this );
      oLea_0076_0081 = new Lea_0076_0081( this );
      mNrStates = 5;
      mStates = new TsmState*[ mNrStates ];
      mStates[ 0 ] = oIni_0076_0077;
      mStates[ 1 ] = oFin_0076_0078;
      mStates[ 2 ] = oCho_0076_0079;
      mStates[ 3 ] = oLea_0076_0080;
      mStates[ 4 ] = oLea_0076_0081;
    }

    void Initial( TsmHandler& oHandler );
    void Tra_0076_0082( TsmHandler& oHandler );
    void Tra_0076_0084( TsmHandler& oHandler );
    void Tra_0076_0086( TsmHandler& oHandler );
    void Tra_0076_0085( TsmHandler& oHandler );
    void Tra_0076_0083( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 69:
        switch ( Command )
        {
        case 2:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 82:
        Tra_0076_0082( oHandler );
        break;
      case 84:
        Tra_0076_0084( oHandler );
        break;
      case 86:
        Tra_0076_0086( oHandler );
        break;
      case 85:
        Tra_0076_0085( oHandler );
        break;
      case 83:
        Tra_0076_0083( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Twin > ActorComponent > ActorClass > ActorFsm >> CompoundState >> InitialState )
  class Ini_0087_0088 : public TsmPseudo
  {
  public:
    Ini_0087_0088( TsmBase* oParent )
    {
      TsmName = "InitialState";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 91, "( ActorFsm >> CompoundState >> InitialState ) => ( ActorFsm >> CompoundState >> Answered )" );
    }

    void Initial( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 91: // UP: ( ActorFsm >> CompoundState >> InitialState ) => ( ActorFsm >> CompoundState >> Answered )
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Twin > ActorComponent > ActorClass > ActorFsm >> CompoundState >> Answered )
  class Lea_0087_0089 : public TsmLeaf
  {
  public:
    Lea_0087_0089( TsmBase* oParent )
    {
      TsmName = "Answered";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 92, "( ActorFsm >> CompoundState >> Answered ) => ( ActorFsm >> CompoundState >> Thinking ) : rp_In->CbQuestion" );
    }

    void Tra_0087_0091( TsmHandler& oHandler );

    void Initial( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::OK;
    }
    void rp_In___CbQuestion( string sQuestion, TsmHandler& oHandler );
    void Tra_0087_0093( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void ExecuteTrigger( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 69:
        switch ( Command )
        {
        case 1:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 91:
        Tra_0087_0091( oHandler );
        break;
      case 92: // UP: ( ActorFsm >> CompoundState >> Answered ) => ( ActorFsm >> CompoundState >> Thinking )
        bHigher = true;
        break;
      case 93:
        Tra_0087_0093( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Twin > ActorComponent > ActorClass > ActorFsm >> CompoundState >> Thinking )
  class Lea_0087_0090 : public TsmLeaf
  {
  public:
    Lea_0087_0090( TsmBase* oParent )
    {
      TsmName = "Thinking";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 93, "( ActorFsm >> CompoundState >> Thinking ) => ( ActorFsm >> CompoundState >> Answered ) : rp_Oracle->CbReply" );
    }

    void Initial( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::OK;
    }
    void Tra_0087_0092( TsmHandler& oHandler );
    void rp_Oracle___CbReply( string sReply, TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void ExecuteTrigger( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 71:
        switch ( Command )
        {
        case 4:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 92:
        Tra_0087_0092( oHandler );
        break;
      case 93: // UP: ( ActorFsm >> CompoundState >> Thinking ) => ( ActorFsm >> CompoundState >> Answered )
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Twin > ActorComponent > ActorClass > ActorFsm >> CompoundState >)
  class Reg_0075_0087 : public TsmRegion
  {
  private:
    Ini_0087_0088* oIni_0087_0088; // ( Xmi > Data > Repository > Twin > ActorComponent > ActorClass > ActorFsm >> CompoundState >> InitialState )
    Lea_0087_0089* oLea_0087_0089; // ( Xmi > Data > Repository > Twin > ActorComponent > ActorClass > ActorFsm >> CompoundState >> Answered )
    Lea_0087_0090* oLea_0087_0090; // ( Xmi > Data > Repository > Twin > ActorComponent > ActorClass > ActorFsm >> CompoundState >> Thinking )

  public:
    Reg_0075_0087( TsmBase* oParent )
    {
      TsmName = "";
      TsmParent = oParent;
      oIni_0087_0088 = new Ini_0087_0088( this );
      oLea_0087_0089 = new Lea_0087_0089( this );
      oLea_0087_0090 = new Lea_0087_0090( this );
      mNrStates = 3;
      mStates = new TsmState*[ mNrStates ];
      mStates[ 0 ] = oIni_0087_0088;
      mStates[ 1 ] = oLea_0087_0089;
      mStates[ 2 ] = oLea_0087_0090;
    }

    void Initial( TsmHandler& oHandler );
    void Tra_0087_0091( TsmHandler& oHandler );
    void Tra_0087_0092( TsmHandler& oHandler );
    void Tra_0087_0093( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 69:
        switch ( Command )
        {
        case 1:
          return TsmProspect::OK;
        default:
          break;
        }
        break; // end of Port 69
      case 71:
        switch ( Command )
        {
        case 4:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 91:
        Tra_0087_0091( oHandler );
        break;
      case 92:
        Tra_0087_0092( oHandler );
        break;
      case 93:
        Tra_0087_0093( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Twin > ActorComponent > ActorClass > ActorFsm >> CompoundState )
  class Com_0073_0075 : public TsmCompound
  {
  private:
    Reg_0075_0076* oReg_0075_0076; // ( Xmi > Data > Repository > Twin > ActorComponent > ActorClass > ActorFsm >> CompoundState >)
    Reg_0075_0087* oReg_0075_0087; // ( Xmi > Data > Repository > Twin > ActorComponent > ActorClass > ActorFsm >> CompoundState >)

  public:
    Com_0073_0075( TsmBase* oParent )
    {
      TsmName = "CS_75";
      TsmParent = oParent;
      oReg_0075_0076 = new Reg_0075_0076( this );
      oReg_0075_0087 = new Reg_0075_0087( this );
      mNrRegions = 2;
      mRegions = new TsmRegion*[ mNrRegions ];
      mRegions[ 0 ] = oReg_0075_0076;
      mRegions[ 1 ] = oReg_0075_0087;
      mNrTransitions = 0;
    }

    void Tra_0073_0094( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 94:
        Tra_0073_0094( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Twin > ActorComponent > ActorClass > ActorFsm >)
  class Reg_0072_0073 : public TsmRegion
  {
  private:
    Ini_0073_0074* oIni_0073_0074; // ( Xmi > Data > Repository > Twin > ActorComponent > ActorClass > ActorFsm >> InitialState )
    Com_0073_0075* oCom_0073_0075; // ( Xmi > Data > Repository > Twin > ActorComponent > ActorClass > ActorFsm >> CompoundState )

  public:
    Reg_0072_0073( TsmBase* oParent )
    {
      TsmName = "";
      TsmParent = oParent;
      oIni_0073_0074 = new Ini_0073_0074( this );
      oCom_0073_0075 = new Com_0073_0075( this );
      mNrStates = 2;
      mStates = new TsmState*[ mNrStates ];
      mStates[ 0 ] = oIni_0073_0074;
      mStates[ 1 ] = oCom_0073_0075;
    }

    void Initial( TsmHandler& oHandler );
    void Tra_0073_0094( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 69:
        switch ( Command )
        {
        case 1:
          return TsmProspect::OK;
        case 2:
          return TsmProspect::OK;
        default:
          break;
        }
        break; // end of Port 69
      case 71:
        switch ( Command )
        {
        case 4:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 94:
        Tra_0073_0094( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Twin > ActorComponent > ActorClass > ActorFsm )
  class Fsm_0068_0072 : public TsmFsm
  {
  private:
    Reg_0072_0073* oReg_0072_0073; // ( Xmi > Data > Repository > Twin > ActorComponent > ActorClass > ActorFsm >)

  public:
    Fsm_0068_0072( TsmBase* oParent )
    {
      TsmName = "ActorFsm";
      TsmParent = oParent;
      oReg_0072_0073 = new Reg_0072_0073( this );
      mNrRegions = 1;
      mRegions = new TsmRegion*[ mNrRegions ];
      mRegions[ 0 ] = oReg_0072_0073;
      mNrTransitions = 0;
    }

    void AtEntry( TsmHandler& oHandler );
  };

   // ( Xmi > Data > Repository > Twin > ActorComponent > ActorClass )
  class Cla_0066_0068 : public TsmClass
  {
  private:
    Fsm_0068_0072* oFsm_0068_0072; // ( Xmi > Data > Repository > Twin > ActorComponent > ActorClass > ActorFsm )
    TsmIPort_ICbTwin* TsmPI__rp_In; // ( Xmi > Data > Repository > Twin > ActorComponent > ActorClass > rp_In )
    TsmIPort_ICbTwin* pp_Out; // ( Xmi > Data > Repository > Twin > ActorComponent > ActorClass > pp_Out )
    TsmIPort_IOracle* rp_Oracle; // ( Xmi > Data > Repository > Twin > ActorComponent > ActorClass > rp_Oracle )
    TsmIPort_ICbOracle* TsmPI__rp_Oracle; // ( Xmi > Data > Repository > Twin > ActorComponent > ActorClass > rp_Oracle )
    TsmPCPort* mPCMessager;
    int MaxNumQuestion;
    int NumQuestion;

  public:
    Cla_0066_0068( TsmBase* oParent, string sInstanceName ) : MaxNumQuestion(10)
    {
      TsmName = sInstanceName;
      TsmParent = oParent;
      oFsm_0068_0072 = new Fsm_0068_0072( this );
      TsmPI__rp_In = new TsmIPort_ICbTwin( this );
      TsmPI__rp_Oracle = new TsmIPort_ICbOracle( this );
      mPCMessager = new TsmPCPort();
      mNrFsms = 1;
      oFsms = new TsmFsm*[ 1 ];
      oFsms[ 0 ] = oFsm_0068_0072;
    }

    TsmInterfacePort* GetProvidedInterface( string sPortName )
    {
      if ( sPortName == "rp_In" )
      {
        return TsmPI__rp_In;
      }
      if ( sPortName == "rp_Oracle" )
      {
        return TsmPI__rp_Oracle;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Repository > Twin > ActorComponent > ActorClass )";
      throw TsmException( s );
    }

    void SetRequiredInterface( string sPortName, TsmInterfacePort* oProvidedInterface )
    {
      if ( sPortName == "pp_Out" )
      {
        pp_Out = static_cast<TsmIPort_ICbTwin*>(oProvidedInterface);
        pp_Out->Source = this;
        return;
      }
      if ( sPortName == "rp_Oracle" )
      {
        rp_Oracle = static_cast<TsmIPort_IOracle*>(oProvidedInterface);
        rp_Oracle->Source = this;
        return;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Repository > Twin > ActorComponent > ActorClass )";
      throw TsmException( s );
    }

    void ExecuteTrigger( TsmTrigger* oTrigger )
    {
      SnapCall = oTrigger->Snap();
      TsmHandler lHandler( this, oTrigger );
      oFsm_0068_0072->ExecuteTriggerFsm( lHandler );
      SnapCall = "";
      SnapState.clear();
    }
    void Function_1002( TsmHandler& oHandler );
    bool Guard_1003();
    void Function_1004( TsmHandler& oHandler );
    void Function_1005( TsmHandler& oHandler );
    void Function_1006( TsmHandler& oHandler );
    void Function_1015( TsmHandler& oHandler );
    void Function_1016( TsmHandler& oHandler );
    void Function_1017( TsmHandler& oHandler );
    void TsmInitialise( void* oObject );
    void TsmConnect( void* oObject );
    void TsmPrepare( void* oObject );

    ~Cla_0066_0068()
    {
      delete TsmPI__rp_In;
      delete TsmPI__rp_Oracle;
      delete mPCMessager;
    }
  };

   // ( Xmi > Data > Repository > Twin > ActorComponent )
  class Com_0053_0066 : public TsmPComponent
  {
  private:
    Cla_0066_0068* Actor; // ( Xmi > Data > Repository > Twin > ActorComponent > Actor )

  public:
    Com_0053_0066( TsmBase* oParent, string sInstanceName )
    {
      TsmName = sInstanceName;
      TsmParent = oParent;
      Actor = new Cla_0066_0068( this, "Actor" );
      mNrClasses = 1;
      mClasses = new TsmClass*[ 1 ];
      mClasses[ 0 ] = Actor;
    }

    TsmInterfacePort* GetProvidedInterface( string sPortName )
    {
      if ( sPortName == "In" )
      {
        return Actor->GetProvidedInterface( "rp_In" );
      }
      if ( sPortName == "rp_Oracle" )
      {
        return Actor->GetProvidedInterface( "rp_Oracle" );
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Repository > Twin > ActorComponent )";
      throw TsmException( s );
    }

    void SetRequiredInterface( string sPortName, TsmInterfacePort* oProvidedInterface )
    {
      if ( sPortName == "In" )
      {
        Actor->SetRequiredInterface( "rp_In", oProvidedInterface );
        return;
      }
      if ( sPortName == "Out" )
      {
        Actor->SetRequiredInterface( "pp_Out", oProvidedInterface );
        return;
      }
      if ( sPortName == "rp_Oracle" )
      {
        Actor->SetRequiredInterface( "rp_Oracle", oProvidedInterface );
        return;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Repository > Twin > ActorComponent )";
      throw TsmException( s );
    }
  };

   // ( Xmi > Data > Repository > Twin > OracleComponent > OracleClass > OracleFsm >> InitialState )
  class Ini_0059_0060 : public TsmPseudo
  {
  public:
    Ini_0059_0060( TsmBase* oParent )
    {
      TsmName = "InitialState";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 63, "( OracleFsm >> InitialState ) => ( OracleFsm >> Idle )" );
    }

    void Initial( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 63: // UP: ( OracleFsm >> InitialState ) => ( OracleFsm >> Idle )
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Twin > OracleComponent > OracleClass > OracleFsm >> Idle )
  class Lea_0059_0061 : public TsmLeaf
  {
  public:
    Lea_0059_0061( TsmBase* oParent )
    {
      TsmName = "Idle";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 64, "( OracleFsm >> Idle ) => ( OracleFsm >> Asked ) : Pythia->Ask" );
    }

    void Tra_0059_0063( TsmHandler& oHandler );

    void Initial( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::OK;
    }
    void Tra_0059_0065( TsmHandler& oHandler );
    void Pythia___Ask( string sAsk, TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void ExecuteTrigger( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 57:
        switch ( Command )
        {
        case 3:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 63:
        Tra_0059_0063( oHandler );
        break;
      case 65:
        Tra_0059_0065( oHandler );
        break;
      case 64: // UP: ( OracleFsm >> Idle ) => ( OracleFsm >> Asked )
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Twin > OracleComponent > OracleClass > OracleFsm >> Asked )
  class Lea_0059_0062 : public TsmLeaf
  {
  public:
    Lea_0059_0062( TsmBase* oParent )
    {
      TsmName = "Asked";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 65, "( OracleFsm >> Asked ) => ( OracleFsm >> Idle )" );
    }

    void Initial( TsmHandler& oHandler );
    void Tra_0059_0064( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 65: // UP: ( OracleFsm >> Asked ) => ( OracleFsm >> Idle )
        bHigher = true;
        break;
      case 64:
        Tra_0059_0064( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Twin > OracleComponent > OracleClass > OracleFsm >)
  class Reg_0058_0059 : public TsmRegion
  {
  private:
    Ini_0059_0060* oIni_0059_0060; // ( Xmi > Data > Repository > Twin > OracleComponent > OracleClass > OracleFsm >> InitialState )
    Lea_0059_0061* oLea_0059_0061; // ( Xmi > Data > Repository > Twin > OracleComponent > OracleClass > OracleFsm >> Idle )
    Lea_0059_0062* oLea_0059_0062; // ( Xmi > Data > Repository > Twin > OracleComponent > OracleClass > OracleFsm >> Asked )

  public:
    Reg_0058_0059( TsmBase* oParent )
    {
      TsmName = "";
      TsmParent = oParent;
      oIni_0059_0060 = new Ini_0059_0060( this );
      oLea_0059_0061 = new Lea_0059_0061( this );
      oLea_0059_0062 = new Lea_0059_0062( this );
      mNrStates = 3;
      mStates = new TsmState*[ mNrStates ];
      mStates[ 0 ] = oIni_0059_0060;
      mStates[ 1 ] = oLea_0059_0061;
      mStates[ 2 ] = oLea_0059_0062;
    }

    void Initial( TsmHandler& oHandler );
    void Tra_0059_0063( TsmHandler& oHandler );
    void Tra_0059_0065( TsmHandler& oHandler );
    void Tra_0059_0064( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 57:
        switch ( Command )
        {
        case 3:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 63:
        Tra_0059_0063( oHandler );
        break;
      case 65:
        Tra_0059_0065( oHandler );
        break;
      case 64:
        Tra_0059_0064( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Twin > OracleComponent > OracleClass > OracleFsm )
  class Fsm_0056_0058 : public TsmFsm
  {
  private:
    Reg_0058_0059* oReg_0058_0059; // ( Xmi > Data > Repository > Twin > OracleComponent > OracleClass > OracleFsm >)

  public:
    Fsm_0056_0058( TsmBase* oParent )
    {
      TsmName = "OracleFsm";
      TsmParent = oParent;
      oReg_0058_0059 = new Reg_0058_0059( this );
      mNrRegions = 1;
      mRegions = new TsmRegion*[ mNrRegions ];
      mRegions[ 0 ] = oReg_0058_0059;
      mNrTransitions = 0;
    }

    void AtEntry( TsmHandler& oHandler );
  };

   // ( Xmi > Data > Repository > Twin > OracleComponent > OracleClass )
  class Cla_0054_0056 : public TsmClass
  {
  private:
    Fsm_0056_0058* oFsm_0056_0058; // ( Xmi > Data > Repository > Twin > OracleComponent > OracleClass > OracleFsm )
    TsmIPort_IOracle* TsmPI__Pythia; // ( Xmi > Data > Repository > Twin > OracleComponent > OracleClass > Pythia )
    TsmIPort_ICbOracle* Pythia; // ( Xmi > Data > Repository > Twin > OracleComponent > OracleClass > Pythia )
    TsmPSPort* mPSMessager;
    string MyAsk;

  public:
    Cla_0054_0056( TsmBase* oParent, string sInstanceName )
    {
      TsmName = sInstanceName;
      TsmParent = oParent;
      oFsm_0056_0058 = new Fsm_0056_0058( this );
      TsmPI__Pythia = new TsmIPort_IOracle( this );
      mPSMessager = new TsmPSPort();
      mNrFsms = 1;
      oFsms = new TsmFsm*[ 1 ];
      oFsms[ 0 ] = oFsm_0056_0058;
    }

    TsmInterfacePort* GetProvidedInterface( string sPortName )
    {
      if ( sPortName == "Pythia" )
      {
        return TsmPI__Pythia;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Repository > Twin > OracleComponent > OracleClass )";
      throw TsmException( s );
    }

    void SetRequiredInterface( string sPortName, TsmInterfacePort* oProvidedInterface )
    {
      if ( sPortName == "Pythia" )
      {
        Pythia = static_cast<TsmIPort_ICbOracle*>(oProvidedInterface);
        Pythia->Source = this;
        return;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Repository > Twin > OracleComponent > OracleClass )";
      throw TsmException( s );
    }

    void ExecuteTrigger( TsmTrigger* oTrigger )
    {
      SnapCall = oTrigger->Snap();
      TsmHandler lHandler( this, oTrigger );
      oFsm_0056_0058->ExecuteTriggerFsm( lHandler );
      SnapCall = "";
      SnapState.clear();
    }
    void Function_1001( TsmHandler& oHandler );
    void Function_1014( TsmHandler& oHandler );
    void TsmInitialise( void* oObject );
    void TsmConnect( void* oObject );
    void TsmPrepare( void* oObject );

    ~Cla_0054_0056()
    {
      delete TsmPI__Pythia;
      delete mPSMessager;
    }
  };

   // ( Xmi > Data > Repository > Twin > OracleComponent )
  class Com_0053_0054 : public TsmPComponent
  {
  private:
    Cla_0054_0056* Delphi; // ( Xmi > Data > Repository > Twin > OracleComponent > Delphi )

  public:
    Com_0053_0054( TsmBase* oParent, string sInstanceName )
    {
      TsmName = sInstanceName;
      TsmParent = oParent;
      Delphi = new Cla_0054_0056( this, "Delphi" );
      mNrClasses = 1;
      mClasses = new TsmClass*[ 1 ];
      mClasses[ 0 ] = Delphi;
    }

    TsmInterfacePort* GetProvidedInterface( string sPortName )
    {
      if ( sPortName == "pp_Oracle" )
      {
        return Delphi->GetProvidedInterface( "Pythia" );
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Repository > Twin > OracleComponent )";
      throw TsmException( s );
    }

    void SetRequiredInterface( string sPortName, TsmInterfacePort* oProvidedInterface )
    {
      if ( sPortName == "pp_Oracle" )
      {
        Delphi->SetRequiredInterface( "Pythia", oProvidedInterface );
        return;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Repository > Twin > OracleComponent )";
      throw TsmException( s );
    }
  };

   // ( Xmi > Data > Repository > Twin > TwinComponent )
  class Com_0053_0095 : public TsmAComponent
  {
  private:
    Com_0053_0066* ActorComp; // ( Xmi > Data > Repository > Twin > TwinComponent > ActorComp )
    Com_0053_0054* OracleComp; // ( Xmi > Data > Repository > Twin > TwinComponent > OracleComp )
    TsmIPort_ICbTwin* TsmPI__In; // ( Xmi > Data > Repository > Twin > TwinComponent > In )
    TsmACPort* TsmMr__In;

  public:
    Com_0053_0095( TsmBase* oParent, string sInstanceName )
    {
      TsmName = sInstanceName;
      TsmParent = oParent;
      ActorComp = new Com_0053_0066( this, "ActorComp" );
      OracleComp = new Com_0053_0054( this, "OracleComp" );
      mNrComponents = 2;
      mComponents = new TsmComponent*[ 2 ];
      mComponents[ 0 ] = ActorComp;
      mComponents[ 1 ] = OracleComp;
      TsmPI__In = new TsmIPort_ICbTwin( this );
      TsmMr__In = new TsmACPort();
    }

    TsmInterfacePort* GetProvidedInterface( string sPortName )
    {
      if ( sPortName == "In" )
      {
        return TsmPI__In;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Repository > Twin > TwinComponent )";
      throw TsmException( s );
    }

    void SetRequiredInterface( string sPortName, TsmInterfacePort* oProvidedInterface )
    {
      if ( sPortName == "In" )
      {
        ActorComp->SetRequiredInterface( "In", oProvidedInterface );
        return;
      }
      if ( sPortName == "Out" )
      {
        ActorComp->SetRequiredInterface( "Out", oProvidedInterface );
        return;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Repository > Twin > TwinComponent )";
      throw TsmException( s );
    }
    void TsmInitialise( void* oObject );
    void TsmConnect( void* oObject );

    ~Com_0053_0095()
    {
      delete TsmPI__In;
      delete TsmMr__In;
    }
  };

   // ( Xmi > Data > Repository > Twin > TwinMock > TwinMockClass > TwinMockFsm >> InitialState )
  class Ini_0104_0105 : public TsmPseudo
  {
  public:
    Ini_0104_0105( TsmBase* oParent )
    {
      TsmName = "InitialState";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 121, "( TwinMockFsm >> InitialState ) => ( TwinMockFsm >> CompoundState )" );
    }

    void Initial( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 121: // UP: ( TwinMockFsm >> InitialState ) => ( TwinMockFsm >> CompoundState )
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Twin > TwinMock > TwinMockClass > TwinMockFsm >> CompoundState >> InitialState )
  class Ini_0107_0108 : public TsmPseudo
  {
  public:
    Ini_0107_0108( TsmBase* oParent )
    {
      TsmName = "InitialState";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 111, "( TwinMockFsm >> CompoundState >> InitialState ) => ( TwinMockFsm >> CompoundState >> Idle )" );
    }

    void Initial( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 111: // UP: ( TwinMockFsm >> CompoundState >> InitialState ) => ( TwinMockFsm >> CompoundState >> Idle )
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Twin > TwinMock > TwinMockClass > TwinMockFsm >> CompoundState >> Idle )
  class Lea_0107_0109 : public TsmLeaf
  {
  private:
    static const int aNatives[1];

  public:
    Lea_0107_0109( TsmBase* oParent )
    {
      TsmName = "Idle";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 112, "( TwinMockFsm >> CompoundState >> Idle ) => ( TwinMockFsm >> CompoundState >> Asking )" );
    }

    void Tra_0107_0111( TsmHandler& oHandler );

    void Initial( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::OK;
    }
    void Tra_0107_0113( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void AtExit( TsmHandler& oHandler );
    void ExecuteTrigger( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 112:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 111:
        Tra_0107_0111( oHandler );
        break;
      case 112: // UP: ( TwinMockFsm >> CompoundState >> Idle ) => ( TwinMockFsm >> CompoundState >> Asking )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 113:
        Tra_0107_0113( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Twin > TwinMock > TwinMockClass > TwinMockFsm >> CompoundState >> Asking )
  class Lea_0107_0110 : public TsmLeaf
  {
  public:
    Lea_0107_0110( TsmBase* oParent )
    {
      TsmName = "Asking";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 113, "( TwinMockFsm >> CompoundState >> Asking ) => ( TwinMockFsm >> CompoundState >> Idle ) : rp_In2->CbAnswer" );
    }

    void Initial( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::OK;
    }
    void Tra_0107_0112( TsmHandler& oHandler );
    void rp_In2___CbAnswer( string sAnswer, TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void ExecuteTrigger( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 101:
        switch ( Command )
        {
        case 2:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 112:
        Tra_0107_0112( oHandler );
        break;
      case 113: // UP: ( TwinMockFsm >> CompoundState >> Asking ) => ( TwinMockFsm >> CompoundState >> Idle )
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Twin > TwinMock > TwinMockClass > TwinMockFsm >> CompoundState >)
  class Reg_0106_0107 : public TsmRegion
  {
  private:
    Ini_0107_0108* oIni_0107_0108; // ( Xmi > Data > Repository > Twin > TwinMock > TwinMockClass > TwinMockFsm >> CompoundState >> InitialState )
    Lea_0107_0109* oLea_0107_0109; // ( Xmi > Data > Repository > Twin > TwinMock > TwinMockClass > TwinMockFsm >> CompoundState >> Idle )
    Lea_0107_0110* oLea_0107_0110; // ( Xmi > Data > Repository > Twin > TwinMock > TwinMockClass > TwinMockFsm >> CompoundState >> Asking )

  public:
    Reg_0106_0107( TsmBase* oParent )
    {
      TsmName = "";
      TsmParent = oParent;
      oIni_0107_0108 = new Ini_0107_0108( this );
      oLea_0107_0109 = new Lea_0107_0109( this );
      oLea_0107_0110 = new Lea_0107_0110( this );
      mNrStates = 3;
      mStates = new TsmState*[ mNrStates ];
      mStates[ 0 ] = oIni_0107_0108;
      mStates[ 1 ] = oLea_0107_0109;
      mStates[ 2 ] = oLea_0107_0110;
    }

    void Initial( TsmHandler& oHandler );
    void Tra_0107_0111( TsmHandler& oHandler );
    void Tra_0107_0112( TsmHandler& oHandler );
    void Tra_0107_0113( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 112:
          return TsmProspect::OK;
        default:
          break;
        }
        break; // end of Port -1
      case 101:
        switch ( Command )
        {
        case 2:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 111:
        Tra_0107_0111( oHandler );
        break;
      case 112:
        Tra_0107_0112( oHandler );
        break;
      case 113:
        Tra_0107_0113( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Twin > TwinMock > TwinMockClass > TwinMockFsm >> CompoundState >> InitialState )
  class Ini_0114_0115 : public TsmPseudo
  {
  public:
    Ini_0114_0115( TsmBase* oParent )
    {
      TsmName = "InitialState";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 118, "( TwinMockFsm >> CompoundState >> InitialState ) => ( TwinMockFsm >> CompoundState >> Answered )" );
    }

    void Initial( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 118: // UP: ( TwinMockFsm >> CompoundState >> InitialState ) => ( TwinMockFsm >> CompoundState >> Answered )
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Twin > TwinMock > TwinMockClass > TwinMockFsm >> CompoundState >> Answered )
  class Lea_0114_0116 : public TsmLeaf
  {
  public:
    Lea_0114_0116( TsmBase* oParent )
    {
      TsmName = "Answered";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 119, "( TwinMockFsm >> CompoundState >> Answered ) => ( TwinMockFsm >> CompoundState >> Thinking ) : rp_In2->CbQuestion" );
    }

    void Tra_0114_0118( TsmHandler& oHandler );

    void Initial( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::OK;
    }
    void Tra_0114_0120( TsmHandler& oHandler );
    void rp_In2___CbQuestion( string sQuestion, TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void ExecuteTrigger( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 101:
        switch ( Command )
        {
        case 1:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 118:
        Tra_0114_0118( oHandler );
        break;
      case 120:
        Tra_0114_0120( oHandler );
        break;
      case 119: // UP: ( TwinMockFsm >> CompoundState >> Answered ) => ( TwinMockFsm >> CompoundState >> Thinking )
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Twin > TwinMock > TwinMockClass > TwinMockFsm >> CompoundState >> Thinking )
  class Lea_0114_0117 : public TsmLeaf
  {
  private:
    static const int aNatives[1];

  public:
    Lea_0114_0117( TsmBase* oParent )
    {
      TsmName = "Thinking";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 120, "( TwinMockFsm >> CompoundState >> Thinking ) => ( TwinMockFsm >> CompoundState >> Answered )" );
    }

    void Initial( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::OK;
    }
    void Tra_0114_0119( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void AtExit( TsmHandler& oHandler );
    void ExecuteTrigger( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 120:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 120: // UP: ( TwinMockFsm >> CompoundState >> Thinking ) => ( TwinMockFsm >> CompoundState >> Answered )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 119:
        Tra_0114_0119( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Twin > TwinMock > TwinMockClass > TwinMockFsm >> CompoundState >)
  class Reg_0106_0114 : public TsmRegion
  {
  private:
    Ini_0114_0115* oIni_0114_0115; // ( Xmi > Data > Repository > Twin > TwinMock > TwinMockClass > TwinMockFsm >> CompoundState >> InitialState )
    Lea_0114_0116* oLea_0114_0116; // ( Xmi > Data > Repository > Twin > TwinMock > TwinMockClass > TwinMockFsm >> CompoundState >> Answered )
    Lea_0114_0117* oLea_0114_0117; // ( Xmi > Data > Repository > Twin > TwinMock > TwinMockClass > TwinMockFsm >> CompoundState >> Thinking )

  public:
    Reg_0106_0114( TsmBase* oParent )
    {
      TsmName = "";
      TsmParent = oParent;
      oIni_0114_0115 = new Ini_0114_0115( this );
      oLea_0114_0116 = new Lea_0114_0116( this );
      oLea_0114_0117 = new Lea_0114_0117( this );
      mNrStates = 3;
      mStates = new TsmState*[ mNrStates ];
      mStates[ 0 ] = oIni_0114_0115;
      mStates[ 1 ] = oLea_0114_0116;
      mStates[ 2 ] = oLea_0114_0117;
    }

    void Initial( TsmHandler& oHandler );
    void Tra_0114_0118( TsmHandler& oHandler );
    void Tra_0114_0120( TsmHandler& oHandler );
    void Tra_0114_0119( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 120:
          return TsmProspect::OK;
        default:
          break;
        }
        break; // end of Port -1
      case 101:
        switch ( Command )
        {
        case 1:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 118:
        Tra_0114_0118( oHandler );
        break;
      case 120:
        Tra_0114_0120( oHandler );
        break;
      case 119:
        Tra_0114_0119( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Twin > TwinMock > TwinMockClass > TwinMockFsm >> CompoundState )
  class Com_0104_0106 : public TsmCompound
  {
  private:
    Reg_0106_0107* oReg_0106_0107; // ( Xmi > Data > Repository > Twin > TwinMock > TwinMockClass > TwinMockFsm >> CompoundState >)
    Reg_0106_0114* oReg_0106_0114; // ( Xmi > Data > Repository > Twin > TwinMock > TwinMockClass > TwinMockFsm >> CompoundState >)

  public:
    Com_0104_0106( TsmBase* oParent )
    {
      TsmName = "CS_106";
      TsmParent = oParent;
      oReg_0106_0107 = new Reg_0106_0107( this );
      oReg_0106_0114 = new Reg_0106_0114( this );
      mNrRegions = 2;
      mRegions = new TsmRegion*[ mNrRegions ];
      mRegions[ 0 ] = oReg_0106_0107;
      mRegions[ 1 ] = oReg_0106_0114;
      mNrTransitions = 0;
    }

    void Tra_0104_0121( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 121:
        Tra_0104_0121( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Twin > TwinMock > TwinMockClass > TwinMockFsm >)
  class Reg_0103_0104 : public TsmRegion
  {
  private:
    Ini_0104_0105* oIni_0104_0105; // ( Xmi > Data > Repository > Twin > TwinMock > TwinMockClass > TwinMockFsm >> InitialState )
    Com_0104_0106* oCom_0104_0106; // ( Xmi > Data > Repository > Twin > TwinMock > TwinMockClass > TwinMockFsm >> CompoundState )

  public:
    Reg_0103_0104( TsmBase* oParent )
    {
      TsmName = "";
      TsmParent = oParent;
      oIni_0104_0105 = new Ini_0104_0105( this );
      oCom_0104_0106 = new Com_0104_0106( this );
      mNrStates = 2;
      mStates = new TsmState*[ mNrStates ];
      mStates[ 0 ] = oIni_0104_0105;
      mStates[ 1 ] = oCom_0104_0106;
    }

    void Initial( TsmHandler& oHandler );
    void Tra_0104_0121( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 112:
          return TsmProspect::OK;
        case 120:
          return TsmProspect::OK;
        default:
          break;
        }
        break; // end of Port -1
      case 101:
        switch ( Command )
        {
        case 1:
          return TsmProspect::OK;
        case 2:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 121:
        Tra_0104_0121( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Repository > Twin > TwinMock > TwinMockClass > TwinMockFsm )
  class Fsm_0100_0103 : public TsmFsm
  {
  private:
    Reg_0103_0104* oReg_0103_0104; // ( Xmi > Data > Repository > Twin > TwinMock > TwinMockClass > TwinMockFsm >)

  public:
    Fsm_0100_0103( TsmBase* oParent )
    {
      TsmName = "TwinMockFsm";
      TsmParent = oParent;
      oReg_0103_0104 = new Reg_0103_0104( this );
      mNrRegions = 1;
      mRegions = new TsmRegion*[ mNrRegions ];
      mRegions[ 0 ] = oReg_0103_0104;
      mNrTransitions = 0;
    }

    void AtEntry( TsmHandler& oHandler );
  };

   // ( Xmi > Data > Repository > Twin > TwinMock > TwinMockClass )
  class Cla_0098_0100 : public TsmClass
  {
  private:
    Fsm_0100_0103* oFsm_0100_0103; // ( Xmi > Data > Repository > Twin > TwinMock > TwinMockClass > TwinMockFsm )
    TsmIPort_ICbTwin* TsmPI__rp_In2; // ( Xmi > Data > Repository > Twin > TwinMock > TwinMockClass > rp_In2 )
    TsmIPort_ICbTwin* pp_Out2; // ( Xmi > Data > Repository > Twin > TwinMock > TwinMockClass > pp_Out2 )
    TsmPCPort* mPCMessager;
    string sQuestion;
    string sAnswer;

  public:
    Cla_0098_0100( TsmBase* oParent, string sInstanceName )
    {
      TsmName = sInstanceName;
      TsmParent = oParent;
      oFsm_0100_0103 = new Fsm_0100_0103( this );
      TsmPI__rp_In2 = new TsmIPort_ICbTwin( this );
      mPCMessager = new TsmPCPort();
      mNrFsms = 1;
      oFsms = new TsmFsm*[ 1 ];
      oFsms[ 0 ] = oFsm_0100_0103;
    }

    TsmInterfacePort* GetProvidedInterface( string sPortName )
    {
      if ( sPortName == "rp_In2" )
      {
        return TsmPI__rp_In2;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Repository > Twin > TwinMock > TwinMockClass )";
      throw TsmException( s );
    }

    void SetRequiredInterface( string sPortName, TsmInterfacePort* oProvidedInterface )
    {
      if ( sPortName == "pp_Out2" )
      {
        pp_Out2 = static_cast<TsmIPort_ICbTwin*>(oProvidedInterface);
        pp_Out2->Source = this;
        return;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Repository > Twin > TwinMock > TwinMockClass )";
      throw TsmException( s );
    }

    void ExecuteTrigger( TsmTrigger* oTrigger )
    {
      SnapCall = oTrigger->Snap();
      TsmHandler lHandler( this, oTrigger );
      oFsm_0100_0103->ExecuteTriggerFsm( lHandler );
      SnapCall = "";
      SnapState.clear();
    }
    void Function_1011( TsmHandler& oHandler );
    void Function_1012( TsmHandler& oHandler );
    void TsmInitialise( void* oObject );
    void TsmConnect( void* oObject );
    void TsmPrepare( void* oObject );

    ~Cla_0098_0100()
    {
      delete TsmPI__rp_In2;
      delete mPCMessager;
    }
  };

   // ( Xmi > Data > Repository > Twin > TwinMock )
  class Com_0053_0098 : public TsmAComponent
  {
  private:
    Cla_0098_0100* Twin; // ( Xmi > Data > Repository > Twin > TwinMock > Twin )
    TsmIPort_ICbTwin* TsmPI__In2; // ( Xmi > Data > Repository > Twin > TwinMock > In2 )
    TsmACPort* TsmMr__In2;

  public:
    Com_0053_0098( TsmBase* oParent, string sInstanceName )
    {
      TsmName = sInstanceName;
      TsmParent = oParent;
      Twin = new Cla_0098_0100( this, "Twin" );
      mNrClasses = 1;
      mClasses = new TsmClass*[ 1 ];
      mClasses[ 0 ] = Twin;
      TsmPI__In2 = new TsmIPort_ICbTwin( this );
      TsmMr__In2 = new TsmACPort();
    }

    TsmInterfacePort* GetProvidedInterface( string sPortName )
    {
      if ( sPortName == "In2" )
      {
        return TsmPI__In2;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Repository > Twin > TwinMock )";
      throw TsmException( s );
    }

    void SetRequiredInterface( string sPortName, TsmInterfacePort* oProvidedInterface )
    {
      if ( sPortName == "In2" )
      {
        Twin->SetRequiredInterface( "rp_In2", oProvidedInterface );
        return;
      }
      if ( sPortName == "Out2" )
      {
        Twin->SetRequiredInterface( "pp_Out2", oProvidedInterface );
        return;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Repository > Twin > TwinMock )";
      throw TsmException( s );
    }
    void TsmInitialise( void* oObject );
    void TsmConnect( void* oObject );

    ~Com_0053_0098()
    {
      delete TsmPI__In2;
      delete TsmMr__In2;
    }
  };

   // ( Xmi > Data > Architecture > TwinsTest )
  class Com_0002_0006 : public TsmPComponent
  {
  private:
    Com_0053_0098* Alice; // ( Xmi > Data > Architecture > TwinsTest > Alice )
    Com_0053_0098* Bob; // ( Xmi > Data > Architecture > TwinsTest > Bob )

  public:
    Com_0002_0006( TsmBase* oParent, string sInstanceName )
    {
      TsmName = sInstanceName;
      TsmParent = oParent;
      Alice = new Com_0053_0098( this, "Alice" );
      Bob = new Com_0053_0098( this, "Bob" );
      mNrComponents = 2;
      mComponents = new TsmComponent*[ 2 ];
      mComponents[ 0 ] = Alice;
      mComponents[ 1 ] = Bob;
    }

    void TsmConnect( void* oObject );
  };

  /********************************************************************
   * PACKAGE: ( Xmi > Data > Architecture > Sequence Diagrams )
   ********************************************************************/

   // ( Xmi > Data > Architecture > Sequence Diagrams )
  class Pac_0002_0009 : public TsmPackage
  {
  public:
    Pac_0002_0009( TsmBase* oParent )
    {
      TsmName = "Sequence Diagrams";
      TsmParent = oParent;
    }
  };

  /********************************************************************
   * PACKAGE: ( Xmi > Data > Architecture )
   ********************************************************************/

   // ( Xmi > Data > Architecture )
  class Pac_0001_0002 : public TsmPackage
  {
  public:
    Pac_0001_0002( TsmBase* oParent )
    {
      TsmName = "Architecture";
      TsmParent = oParent;
    }
  };

  /********************************************************************
   * PACKAGE: ( Xmi > Data > TismStereotypes )
   ********************************************************************/

   // ( Xmi > Data > TismStereotypes )
  class Pac_0001_0010 : public TsmPackage
  {
  public:
    Pac_0001_0010( TsmBase* oParent )
    {
      TsmName = "TismStereotypes";
      TsmParent = oParent;
    }
  };

   // ( Xmi > Data > Protocols > TwinProtocol > TwinClient > TwinClientPsm >> InitialState )
  class Ini_0016_0017 : public TsmPseudo
  {
  public:
    Ini_0016_0017( TsmBase* oParent )
    {
      TsmName = "InitialState";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 19, "( TwinClientPsm >> InitialState ) => ( TwinClientPsm >> Idle )" );
    }

    void Initial( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 19: // UP: ( TwinClientPsm >> InitialState ) => ( TwinClientPsm >> Idle )
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > TwinProtocol > TwinClient > TwinClientPsm >> Idle )
  class Lea_0016_0018 : public TsmLeaf
  {
  public:
    Lea_0016_0018( TsmBase* oParent )
    {
      TsmName = "Idle";
      TsmParent = oParent;
      mNrTransitions = 2;
      mTransitions = new TsmTransition*[ 2 ];
      mTransitions[ 0 ] = new TsmTransition( 20, "( TwinClientPsm >> Idle ) => ( TwinClientPsm >> Idle ) : CbQuestion" );
      mTransitions[ 1 ] = new TsmTransition( 21, "( TwinClientPsm >> Idle ) => ( TwinClientPsm >> Idle ) : CbAnswer" );
    }

    void Tra_0016_0019( TsmHandler& oHandler );

    void Initial( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::OK;
    }
    void Tra_0016_0020( TsmHandler& oHandler );
    void Port___CbQuestion( string sQuestion, TsmHandler& oHandler );
    void Tra_0016_0021( TsmHandler& oHandler );
    void Port___CbAnswer( string sAnswer, TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void ExecuteTrigger( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 14:
        switch ( Command )
        {
        case 1:
          return TsmProspect::OK;
        case 2:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 19:
        Tra_0016_0019( oHandler );
        break;
      case 20:
        Tra_0016_0020( oHandler );
        break;
      case 21:
        Tra_0016_0021( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > TwinProtocol > TwinClient > TwinClientPsm >)
  class Reg_0015_0016 : public TsmRegion
  {
  private:
    Ini_0016_0017* oIni_0016_0017; // ( Xmi > Data > Protocols > TwinProtocol > TwinClient > TwinClientPsm >> InitialState )
    Lea_0016_0018* oLea_0016_0018; // ( Xmi > Data > Protocols > TwinProtocol > TwinClient > TwinClientPsm >> Idle )

  public:
    Reg_0015_0016( TsmBase* oParent )
    {
      TsmName = "";
      TsmParent = oParent;
      oIni_0016_0017 = new Ini_0016_0017( this );
      oLea_0016_0018 = new Lea_0016_0018( this );
      mNrStates = 2;
      mStates = new TsmState*[ mNrStates ];
      mStates[ 0 ] = oIni_0016_0017;
      mStates[ 1 ] = oLea_0016_0018;
    }

    void Initial( TsmHandler& oHandler );
    void Tra_0016_0019( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 14:
        switch ( Command )
        {
        case 1:
          return TsmProspect::OK;
        case 2:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 19:
        Tra_0016_0019( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > TwinProtocol > TwinClient > TwinClientPsm )
  class Fsm_0013_0015 : public TsmFsm
  {
  private:
    Reg_0015_0016* oReg_0015_0016; // ( Xmi > Data > Protocols > TwinProtocol > TwinClient > TwinClientPsm >)

  public:
    Fsm_0013_0015( TsmBase* oParent )
    {
      TsmName = "TwinClientPsm";
      TsmParent = oParent;
      oReg_0015_0016 = new Reg_0015_0016( this );
      mNrRegions = 1;
      mRegions = new TsmRegion*[ mNrRegions ];
      mRegions[ 0 ] = oReg_0015_0016;
      mNrTransitions = 0;
    }

    void AtEntry( TsmHandler& oHandler );
  };

   // ( Xmi > Data > Protocols > TwinProtocol > TwinClient )
  class Cla_0012_0013 : public TsmProtocolClass
  {
  private:
    Fsm_0013_0015* oFsm_0013_0015; // ( Xmi > Data > Protocols > TwinProtocol > TwinClient > TwinClientPsm )
    TsmIPort_ICbTwin* TsmPI__Port; // ( Xmi > Data > Protocols > TwinProtocol > TwinClient > Port )
    TsmPCPort* mPCMessager;

  public:
    Cla_0012_0013( TsmBase* oParent, string sInstanceName )
    {
      TsmName = sInstanceName;
      TsmParent = oParent;
      oFsm_0013_0015 = new Fsm_0013_0015( this );
      TsmPI__Port = new TsmIPort_ICbTwin( this );
      mPCMessager = new TsmPCPort();
      mNrFsms = 1;
      oFsms = new TsmFsm*[ 1 ];
      oFsms[ 0 ] = oFsm_0013_0015;
    }

    TsmInterfacePort* GetProvidedInterface( string sPortName )
    {
      if ( sPortName == "Port" )
      {
        return TsmPI__Port;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Protocols > TwinProtocol > TwinClient )";
      throw TsmException( s );
    }

    void ExecuteTrigger( TsmTrigger* oTrigger )
    {
      SnapCall = oTrigger->Snap();
      TsmHandler lHandler( this, oTrigger );
      oFsm_0013_0015->ExecuteTriggerFsm( lHandler );
      SnapCall = "";
      SnapState.clear();
    }
    void TsmInitialise( void* oObject );
    void TsmConnect( void* oObject );
    void TsmPrepare( void* oObject );

    ~Cla_0012_0013()
    {
      delete TsmPI__Port;
      delete mPCMessager;
    }
  };

   // ( Xmi > Data > Protocols > TwinProtocol > TwinServer > TwinServerPsm >> InitialState )
  class Ini_0025_0026 : public TsmPseudo
  {
  public:
    Ini_0025_0026( TsmBase* oParent )
    {
      TsmName = "InitialState";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 28, "( TwinServerPsm >> InitialState ) => ( TwinServerPsm >> Idle )" );
    }

    void Initial( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 28: // UP: ( TwinServerPsm >> InitialState ) => ( TwinServerPsm >> Idle )
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > TwinProtocol > TwinServer > TwinServerPsm >> Idle )
  class Lea_0025_0027 : public TsmLeaf
  {
  private:
    static const int aNatives[2];

  public:
    Lea_0025_0027( TsmBase* oParent )
    {
      TsmName = "Idle";
      TsmParent = oParent;
      mNrTransitions = 2;
      mTransitions = new TsmTransition*[ 2 ];
      mTransitions[ 0 ] = new TsmTransition( 29, "( TwinServerPsm >> Idle ) => ( TwinServerPsm >> Idle )" );
      mTransitions[ 1 ] = new TsmTransition( 30, "( TwinServerPsm >> Idle ) => ( TwinServerPsm >> Idle )" );
    }

    void Tra_0025_0028( TsmHandler& oHandler );

    void Initial( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::OK;
    }
    void Tra_0025_0029( TsmHandler& oHandler );
    void Tra_0025_0030( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void AtExit( TsmHandler& oHandler );
    void ExecuteTrigger( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 29:
          return TsmProspect::OK;
        case 30:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 28:
        Tra_0025_0028( oHandler );
        break;
      case 29:
        Tra_0025_0029( oHandler );
        break;
      case 30:
        Tra_0025_0030( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > TwinProtocol > TwinServer > TwinServerPsm >)
  class Reg_0024_0025 : public TsmRegion
  {
  private:
    Ini_0025_0026* oIni_0025_0026; // ( Xmi > Data > Protocols > TwinProtocol > TwinServer > TwinServerPsm >> InitialState )
    Lea_0025_0027* oLea_0025_0027; // ( Xmi > Data > Protocols > TwinProtocol > TwinServer > TwinServerPsm >> Idle )

  public:
    Reg_0024_0025( TsmBase* oParent )
    {
      TsmName = "";
      TsmParent = oParent;
      oIni_0025_0026 = new Ini_0025_0026( this );
      oLea_0025_0027 = new Lea_0025_0027( this );
      mNrStates = 2;
      mStates = new TsmState*[ mNrStates ];
      mStates[ 0 ] = oIni_0025_0026;
      mStates[ 1 ] = oLea_0025_0027;
    }

    void Initial( TsmHandler& oHandler );
    void Tra_0025_0028( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 29:
          return TsmProspect::OK;
        case 30:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 28:
        Tra_0025_0028( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > TwinProtocol > TwinServer > TwinServerPsm )
  class Fsm_0022_0024 : public TsmFsm
  {
  private:
    Reg_0024_0025* oReg_0024_0025; // ( Xmi > Data > Protocols > TwinProtocol > TwinServer > TwinServerPsm >)

  public:
    Fsm_0022_0024( TsmBase* oParent )
    {
      TsmName = "TwinServerPsm";
      TsmParent = oParent;
      oReg_0024_0025 = new Reg_0024_0025( this );
      mNrRegions = 1;
      mRegions = new TsmRegion*[ mNrRegions ];
      mRegions[ 0 ] = oReg_0024_0025;
      mNrTransitions = 0;
    }

    void AtEntry( TsmHandler& oHandler );
  };

   // ( Xmi > Data > Protocols > TwinProtocol > TwinServer )
  class Cla_0012_0022 : public TsmProtocolClass
  {
  private:
    Fsm_0022_0024* oFsm_0022_0024; // ( Xmi > Data > Protocols > TwinProtocol > TwinServer > TwinServerPsm )
    TsmIPort_ICbTwin* Port; // ( Xmi > Data > Protocols > TwinProtocol > TwinServer > Port )
    string sQuestion;
    string sAnswer;

  public:
    Cla_0012_0022( TsmBase* oParent, string sInstanceName ) : sQuestion("The Question"), sAnswer("The Answer")
    {
      TsmName = sInstanceName;
      TsmParent = oParent;
      oFsm_0022_0024 = new Fsm_0022_0024( this );
      mNrFsms = 1;
      oFsms = new TsmFsm*[ 1 ];
      oFsms[ 0 ] = oFsm_0022_0024;
    }

    void SetRequiredInterface( string sPortName, TsmInterfacePort* oProvidedInterface )
    {
      if ( sPortName == "Port" )
      {
        Port = static_cast<TsmIPort_ICbTwin*>(oProvidedInterface);
        Port->Source = this;
        return;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Protocols > TwinProtocol > TwinServer )";
      throw TsmException( s );
    }

    void ExecuteTrigger( TsmTrigger* oTrigger )
    {
      SnapCall = oTrigger->Snap();
      TsmHandler lHandler( this, oTrigger );
      oFsm_0022_0024->ExecuteTriggerFsm( lHandler );
      SnapCall = "";
      SnapState.clear();
    }
    void Function_1007( TsmHandler& oHandler );
    void Function_1008( TsmHandler& oHandler );
    void TsmPrepare( void* oObject );
  };

  /********************************************************************
   * PACKAGE: ( Xmi > Data > Protocols > TwinProtocol )
   ********************************************************************/

   // ( Xmi > Data > Protocols > TwinProtocol )
  class Pac_0011_0012 : public TsmPackage
  {
  public:
    Pac_0011_0012( TsmBase* oParent )
    {
      TsmName = "TwinProtocol";
      TsmParent = oParent;
    }
  };

   // ( Xmi > Data > Protocols > OracleProtocol > OracleServer > OracleServerPsm >> InitialState )
  class Ini_0035_0036 : public TsmPseudo
  {
  public:
    Ini_0035_0036( TsmBase* oParent )
    {
      TsmName = "InitialState";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 39, "( OracleServerPsm >> InitialState ) => ( OracleServerPsm >> Idle )" );
    }

    void Initial( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 39: // UP: ( OracleServerPsm >> InitialState ) => ( OracleServerPsm >> Idle )
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > OracleProtocol > OracleServer > OracleServerPsm >> Idle )
  class Lea_0035_0037 : public TsmLeaf
  {
  public:
    Lea_0035_0037( TsmBase* oParent )
    {
      TsmName = "Idle";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 40, "( OracleServerPsm >> Idle ) => ( OracleServerPsm >> Asked ) : Ask" );
    }

    void Tra_0035_0039( TsmHandler& oHandler );

    void Initial( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::OK;
    }
    void Tra_0035_0041( TsmHandler& oHandler );
    void Port___Ask( string sAsk, TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void ExecuteTrigger( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 33:
        switch ( Command )
        {
        case 3:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 39:
        Tra_0035_0039( oHandler );
        break;
      case 41:
        Tra_0035_0041( oHandler );
        break;
      case 40: // UP: ( OracleServerPsm >> Idle ) => ( OracleServerPsm >> Asked )
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > OracleProtocol > OracleServer > OracleServerPsm >> Asked )
  class Lea_0035_0038 : public TsmLeaf
  {
  private:
    static const int aNatives[1];

  public:
    Lea_0035_0038( TsmBase* oParent )
    {
      TsmName = "Asked";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 41, "( OracleServerPsm >> Asked ) => ( OracleServerPsm >> Idle )" );
    }

    void Initial( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::OK;
    }
    void Tra_0035_0040( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void AtExit( TsmHandler& oHandler );
    void ExecuteTrigger( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 41:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 41: // UP: ( OracleServerPsm >> Asked ) => ( OracleServerPsm >> Idle )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 40:
        Tra_0035_0040( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > OracleProtocol > OracleServer > OracleServerPsm >)
  class Reg_0034_0035 : public TsmRegion
  {
  private:
    Ini_0035_0036* oIni_0035_0036; // ( Xmi > Data > Protocols > OracleProtocol > OracleServer > OracleServerPsm >> InitialState )
    Lea_0035_0037* oLea_0035_0037; // ( Xmi > Data > Protocols > OracleProtocol > OracleServer > OracleServerPsm >> Idle )
    Lea_0035_0038* oLea_0035_0038; // ( Xmi > Data > Protocols > OracleProtocol > OracleServer > OracleServerPsm >> Asked )

  public:
    Reg_0034_0035( TsmBase* oParent )
    {
      TsmName = "";
      TsmParent = oParent;
      oIni_0035_0036 = new Ini_0035_0036( this );
      oLea_0035_0037 = new Lea_0035_0037( this );
      oLea_0035_0038 = new Lea_0035_0038( this );
      mNrStates = 3;
      mStates = new TsmState*[ mNrStates ];
      mStates[ 0 ] = oIni_0035_0036;
      mStates[ 1 ] = oLea_0035_0037;
      mStates[ 2 ] = oLea_0035_0038;
    }

    void Initial( TsmHandler& oHandler );
    void Tra_0035_0039( TsmHandler& oHandler );
    void Tra_0035_0041( TsmHandler& oHandler );
    void Tra_0035_0040( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 41:
          return TsmProspect::OK;
        default:
          break;
        }
        break; // end of Port -1
      case 33:
        switch ( Command )
        {
        case 3:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 39:
        Tra_0035_0039( oHandler );
        break;
      case 41:
        Tra_0035_0041( oHandler );
        break;
      case 40:
        Tra_0035_0040( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > OracleProtocol > OracleServer > OracleServerPsm )
  class Fsm_0032_0034 : public TsmFsm
  {
  private:
    Reg_0034_0035* oReg_0034_0035; // ( Xmi > Data > Protocols > OracleProtocol > OracleServer > OracleServerPsm >)

  public:
    Fsm_0032_0034( TsmBase* oParent )
    {
      TsmName = "OracleServerPsm";
      TsmParent = oParent;
      oReg_0034_0035 = new Reg_0034_0035( this );
      mNrRegions = 1;
      mRegions = new TsmRegion*[ mNrRegions ];
      mRegions[ 0 ] = oReg_0034_0035;
      mNrTransitions = 0;
    }

    void AtEntry( TsmHandler& oHandler );
  };

   // ( Xmi > Data > Protocols > OracleProtocol > OracleServer )
  class Cla_0031_0032 : public TsmProtocolClass
  {
  private:
    Fsm_0032_0034* oFsm_0032_0034; // ( Xmi > Data > Protocols > OracleProtocol > OracleServer > OracleServerPsm )
    TsmIPort_IOracle* TsmPI__Port; // ( Xmi > Data > Protocols > OracleProtocol > OracleServer > Port )
    TsmIPort_ICbOracle* Port; // ( Xmi > Data > Protocols > OracleProtocol > OracleServer > Port )
    TsmPSPort* mPSMessager;
    string MyAsk;

  public:
    Cla_0031_0032( TsmBase* oParent, string sInstanceName )
    {
      TsmName = sInstanceName;
      TsmParent = oParent;
      oFsm_0032_0034 = new Fsm_0032_0034( this );
      TsmPI__Port = new TsmIPort_IOracle( this );
      mPSMessager = new TsmPSPort();
      mNrFsms = 1;
      oFsms = new TsmFsm*[ 1 ];
      oFsms[ 0 ] = oFsm_0032_0034;
    }

    TsmInterfacePort* GetProvidedInterface( string sPortName )
    {
      if ( sPortName == "Port" )
      {
        return TsmPI__Port;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Protocols > OracleProtocol > OracleServer )";
      throw TsmException( s );
    }

    void SetRequiredInterface( string sPortName, TsmInterfacePort* oProvidedInterface )
    {
      if ( sPortName == "Port" )
      {
        Port = static_cast<TsmIPort_ICbOracle*>(oProvidedInterface);
        Port->Source = this;
        return;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Protocols > OracleProtocol > OracleServer )";
      throw TsmException( s );
    }

    void ExecuteTrigger( TsmTrigger* oTrigger )
    {
      SnapCall = oTrigger->Snap();
      TsmHandler lHandler( this, oTrigger );
      oFsm_0032_0034->ExecuteTriggerFsm( lHandler );
      SnapCall = "";
      SnapState.clear();
    }
    void Function_1009( TsmHandler& oHandler );
    void Function_1013( TsmHandler& oHandler );
    void TsmInitialise( void* oObject );
    void TsmConnect( void* oObject );
    void TsmPrepare( void* oObject );

    ~Cla_0031_0032()
    {
      delete TsmPI__Port;
      delete mPSMessager;
    }
  };

   // ( Xmi > Data > Protocols > OracleProtocol > OracleClient > OracleClientPsm >> InitialState )
  class Ini_0045_0046 : public TsmPseudo
  {
  public:
    Ini_0045_0046( TsmBase* oParent )
    {
      TsmName = "InitialState";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 49, "( OracleClientPsm >> InitialState ) => ( OracleClientPsm >> Idle )" );
    }

    void Initial( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 49: // UP: ( OracleClientPsm >> InitialState ) => ( OracleClientPsm >> Idle )
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > OracleProtocol > OracleClient > OracleClientPsm >> Idle )
  class Lea_0045_0047 : public TsmLeaf
  {
  private:
    static const int aNatives[1];

  public:
    Lea_0045_0047( TsmBase* oParent )
    {
      TsmName = "Idle";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 50, "( OracleClientPsm >> Idle ) => ( OracleClientPsm >> Asking )" );
    }

    void Tra_0045_0049( TsmHandler& oHandler );

    void Initial( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::OK;
    }
    void Tra_0045_0051( TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void AtExit( TsmHandler& oHandler );
    void ExecuteTrigger( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 50:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 49:
        Tra_0045_0049( oHandler );
        break;
      case 50: // UP: ( OracleClientPsm >> Idle ) => ( OracleClientPsm >> Asking )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 51:
        Tra_0045_0051( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > OracleProtocol > OracleClient > OracleClientPsm >> Asking )
  class Lea_0045_0048 : public TsmLeaf
  {
  public:
    Lea_0045_0048( TsmBase* oParent )
    {
      TsmName = "Asking";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition*[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 51, "( OracleClientPsm >> Asking ) => ( OracleClientPsm >> Idle ) : CbReply" );
    }

    void Initial( TsmHandler& oHandler )
    {
      oHandler.Action = TsmHandlerAction::OK;
    }
    void Tra_0045_0050( TsmHandler& oHandler );
    void Port___CbReply( string sReply, TsmHandler& oHandler );
    void AtEntry( TsmHandler& oHandler );
    void ExecuteTrigger( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 43:
        switch ( Command )
        {
        case 4:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 50:
        Tra_0045_0050( oHandler );
        break;
      case 51: // UP: ( OracleClientPsm >> Asking ) => ( OracleClientPsm >> Idle )
        bHigher = true;
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > OracleProtocol > OracleClient > OracleClientPsm >)
  class Reg_0044_0045 : public TsmRegion
  {
  private:
    Ini_0045_0046* oIni_0045_0046; // ( Xmi > Data > Protocols > OracleProtocol > OracleClient > OracleClientPsm >> InitialState )
    Lea_0045_0047* oLea_0045_0047; // ( Xmi > Data > Protocols > OracleProtocol > OracleClient > OracleClientPsm >> Idle )
    Lea_0045_0048* oLea_0045_0048; // ( Xmi > Data > Protocols > OracleProtocol > OracleClient > OracleClientPsm >> Asking )

  public:
    Reg_0044_0045( TsmBase* oParent )
    {
      TsmName = "";
      TsmParent = oParent;
      oIni_0045_0046 = new Ini_0045_0046( this );
      oLea_0045_0047 = new Lea_0045_0047( this );
      oLea_0045_0048 = new Lea_0045_0048( this );
      mNrStates = 3;
      mStates = new TsmState*[ mNrStates ];
      mStates[ 0 ] = oIni_0045_0046;
      mStates[ 1 ] = oLea_0045_0047;
      mStates[ 2 ] = oLea_0045_0048;
    }

    void Initial( TsmHandler& oHandler );
    void Tra_0045_0049( TsmHandler& oHandler );
    void Tra_0045_0050( TsmHandler& oHandler );
    void Tra_0045_0051( TsmHandler& oHandler );

    int GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 50:
          return TsmProspect::OK;
        default:
          break;
        }
        break; // end of Port -1
      case 43:
        switch ( Command )
        {
        case 4:
          return TsmProspect::OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect::NOK;
    }

    bool ExecuteTransition( TsmHandler& oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 49:
        Tra_0045_0049( oHandler );
        break;
      case 50:
        Tra_0045_0050( oHandler );
        break;
      case 51:
        Tra_0045_0051( oHandler );
        break;
      default:
        throw TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  };

   // ( Xmi > Data > Protocols > OracleProtocol > OracleClient > OracleClientPsm )
  class Fsm_0042_0044 : public TsmFsm
  {
  private:
    Reg_0044_0045* oReg_0044_0045; // ( Xmi > Data > Protocols > OracleProtocol > OracleClient > OracleClientPsm >)

  public:
    Fsm_0042_0044( TsmBase* oParent )
    {
      TsmName = "OracleClientPsm";
      TsmParent = oParent;
      oReg_0044_0045 = new Reg_0044_0045( this );
      mNrRegions = 1;
      mRegions = new TsmRegion*[ mNrRegions ];
      mRegions[ 0 ] = oReg_0044_0045;
      mNrTransitions = 0;
    }

    void AtEntry( TsmHandler& oHandler );
  };

   // ( Xmi > Data > Protocols > OracleProtocol > OracleClient )
  class Cla_0031_0042 : public TsmProtocolClass
  {
  private:
    Fsm_0042_0044* oFsm_0042_0044; // ( Xmi > Data > Protocols > OracleProtocol > OracleClient > OracleClientPsm )
    TsmIPort_IOracle* Port; // ( Xmi > Data > Protocols > OracleProtocol > OracleClient > Port )
    TsmIPort_ICbOracle* TsmPI__Port; // ( Xmi > Data > Protocols > OracleProtocol > OracleClient > Port )
    TsmPCPort* mPCMessager;
    string sAsk;

  public:
    Cla_0031_0042( TsmBase* oParent, string sInstanceName ) : sAsk("Question")
    {
      TsmName = sInstanceName;
      TsmParent = oParent;
      oFsm_0042_0044 = new Fsm_0042_0044( this );
      TsmPI__Port = new TsmIPort_ICbOracle( this );
      mPCMessager = new TsmPCPort();
      mNrFsms = 1;
      oFsms = new TsmFsm*[ 1 ];
      oFsms[ 0 ] = oFsm_0042_0044;
    }

    TsmInterfacePort* GetProvidedInterface( string sPortName )
    {
      if ( sPortName == "Port" )
      {
        return TsmPI__Port;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Protocols > OracleProtocol > OracleClient )";
      throw TsmException( s );
    }

    void SetRequiredInterface( string sPortName, TsmInterfacePort* oProvidedInterface )
    {
      if ( sPortName == "Port" )
      {
        Port = static_cast<TsmIPort_IOracle*>(oProvidedInterface);
        Port->Source = this;
        return;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Protocols > OracleProtocol > OracleClient )";
      throw TsmException( s );
    }

    void ExecuteTrigger( TsmTrigger* oTrigger )
    {
      SnapCall = oTrigger->Snap();
      TsmHandler lHandler( this, oTrigger );
      oFsm_0042_0044->ExecuteTriggerFsm( lHandler );
      SnapCall = "";
      SnapState.clear();
    }
    void Function_1010( TsmHandler& oHandler );
    void TsmInitialise( void* oObject );
    void TsmConnect( void* oObject );
    void TsmPrepare( void* oObject );

    ~Cla_0031_0042()
    {
      delete TsmPI__Port;
      delete mPCMessager;
    }
  };

  /********************************************************************
   * PACKAGE: ( Xmi > Data > Protocols > OracleProtocol )
   ********************************************************************/

   // ( Xmi > Data > Protocols > OracleProtocol )
  class Pac_0011_0031 : public TsmPackage
  {
  public:
    Pac_0011_0031( TsmBase* oParent )
    {
      TsmName = "OracleProtocol";
      TsmParent = oParent;
    }
  };

  /********************************************************************
   * PACKAGE: ( Xmi > Data > Protocols )
   ********************************************************************/

   // ( Xmi > Data > Protocols )
  class Pac_0001_0011 : public TsmPackage
  {
  public:
    Pac_0001_0011( TsmBase* oParent )
    {
      TsmName = "Protocols";
      TsmParent = oParent;
    }
  };

  /********************************************************************
   * PACKAGE: ( Xmi > Data > Repository > Twin )
   ********************************************************************/

   // ( Xmi > Data > Repository > Twin )
  class Pac_0052_0053 : public TsmPackage
  {
  public:
    Pac_0052_0053( TsmBase* oParent )
    {
      TsmName = "Twin";
      TsmParent = oParent;
    }
  };

  /********************************************************************
   * PACKAGE: ( Xmi > Data > Repository )
   ********************************************************************/

   // ( Xmi > Data > Repository )
  class Pac_0001_0052 : public TsmPackage
  {
  public:
    Pac_0001_0052( TsmBase* oParent )
    {
      TsmName = "Repository";
      TsmParent = oParent;
    }
  };

   // ( Xmi )
  class TsmSystem : public TsmExecComponent
  {
  private:
    Com_0002_0006* TwinsTest; // ( Xmi > Data > Architecture > TwinsTest )

  public:
    TsmSystem( TsmBase* oParent )
    {
      TsmName = "Xmi";
      TsmParent = oParent;
      mNrComponents = 1;
      mComponents = new TsmComponent*[ 1 ];
      TwinsTest = new Com_0002_0006( NULL, "TwinsTest" );
      mComponents[ 0 ] = TwinsTest;
    }
  };
}
#endif
